"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.executeReadModel = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _constants = require("./constants");

var executeReadModel = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(_ref) {
    var promise, createQuery, transformEvents, queryExecutor, performAcknowledge, acknowledgePromise, _yield$acknowledgePro, projectionError, error, result;

    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            promise = _ref.promise, createQuery = _ref.createQuery, transformEvents = _ref.transformEvents;

            if (!(promise[_constants.symbol].phase < _constants.Phases.RESOLVER)) {
              _context2.next = 3;
              break;
            }

            throw new TypeError(promise[_constants.symbol].phase);

          case 3:
            queryExecutor = null;
            performAcknowledge = null;
            acknowledgePromise = new Promise(function (resolve) {
              return performAcknowledge = /*#__PURE__*/function () {
                var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(result) {
                  return _regenerator["default"].wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.next = 2;
                          return resolve(result);

                        case 2:
                          return _context.abrupt("return", _context.sent);

                        case 3:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                return function performAcknowledge(_x2) {
                  return _ref3.apply(this, arguments);
                };
              }();
            });
            _context2.prev = 6;
            queryExecutor = createQuery({
              viewModels: [],
              readModels: [{
                name: promise[_constants.symbol].name,
                projection: promise[_constants.symbol].projection,
                resolvers: promise[_constants.symbol].resolvers,
                connectorName: 'ADAPTER_NAME',
                encryption: promise[_constants.symbol].encryption
              }],
              readModelConnectors: {
                ADAPTER_NAME: promise[_constants.symbol].adapter
              },
              getVacantTimeInMillis: function getVacantTimeInMillis() {
                return 0x7fffffff;
              },
              snapshotAdapter: null,
              eventstoreAdapter: {
                getSecretsManager: function getSecretsManager() {
                  return promise[_constants.symbol].secretsManager;
                }
              },
              performAcknowledge: performAcknowledge
            });
            _context2.next = 10;
            return queryExecutor.sendEvents({
              modelName: promise[_constants.symbol].name,
              events: [{
                type: 'Init'
              }]
            });

          case 10:
            _context2.next = 12;
            return queryExecutor.sendEvents({
              modelName: promise[_constants.symbol].name,
              events: transformEvents(promise[_constants.symbol].events)
            });

          case 12:
            _context2.next = 14;
            return acknowledgePromise;

          case 14:
            _yield$acknowledgePro = _context2.sent;
            projectionError = _yield$acknowledgePro.result.error;

            if (!(projectionError != null)) {
              _context2.next = 20;
              break;
            }

            error = new Error(projectionError.message);
            error.stack = projectionError.stack;
            throw error;

          case 20:
            _context2.next = 22;
            return queryExecutor.read({
              modelName: promise[_constants.symbol].name,
              resolverName: promise[_constants.symbol].resolverName,
              resolverArgs: promise[_constants.symbol].resolverArgs,
              jwt: promise[_constants.symbol].jwt
            });

          case 22:
            result = _context2.sent;

            promise[_constants.symbol].resolve(result);

            _context2.next = 29;
            break;

          case 26:
            _context2.prev = 26;
            _context2.t0 = _context2["catch"](6);

            promise[_constants.symbol].reject(_context2.t0);

          case 29:
            _context2.prev = 29;

            if (!queryExecutor) {
              _context2.next = 33;
              break;
            }

            _context2.next = 33;
            return queryExecutor.dispose();

          case 33:
            return _context2.finish(29);

          case 34:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[6, 26, 29, 34]]);
  }));

  return function executeReadModel(_x) {
    return _ref2.apply(this, arguments);
  };
}();

exports.executeReadModel = executeReadModel;
//# sourceMappingURL=execute-read-model.js.map